/*
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;
import org.xtext.example.mydsl.ide.contentassist.antlr.internal.InternalSchemeParser;
import org.xtext.example.mydsl.services.SchemeGrammarAccess;

public class SchemeParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(SchemeGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, SchemeGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getCommandAccess().getAlternatives(), "rule__Command__Alternatives");
			builder.put(grammarAccess.getOperationAccess().getAlternatives_1(), "rule__Operation__Alternatives_1");
			builder.put(grammarAccess.getAnyAccess().getAlternatives(), "rule__Any__Alternatives");
			builder.put(grammarAccess.getDefineAccess().getGroup(), "rule__Define__Group__0");
			builder.put(grammarAccess.getLambdaAccess().getGroup(), "rule__Lambda__Group__0");
			builder.put(grammarAccess.getOperationAccess().getGroup(), "rule__Operation__Group__0");
			builder.put(grammarAccess.getConditionalAccess().getGroup(), "rule__Conditional__Group__0");
			builder.put(grammarAccess.getPrintAccess().getGroup(), "rule__Print__Group__0");
			builder.put(grammarAccess.getListaAccess().getGroup(), "rule__Lista__Group__0");
			builder.put(grammarAccess.getModelAccess().getCommandsAssignment(), "rule__Model__CommandsAssignment");
			builder.put(grammarAccess.getDefineAccess().getVarUmAssignment_2(), "rule__Define__VarUmAssignment_2");
			builder.put(grammarAccess.getDefineAccess().getVarValueAssignment_3(), "rule__Define__VarValueAssignment_3");
			builder.put(grammarAccess.getLambdaAccess().getParamAssignment_3(), "rule__Lambda__ParamAssignment_3");
			builder.put(grammarAccess.getOperationAccess().getArit_opAssignment_1_0(), "rule__Operation__Arit_opAssignment_1_0");
			builder.put(grammarAccess.getOperationAccess().getLog_opAssignment_1_1(), "rule__Operation__Log_opAssignment_1_1");
			builder.put(grammarAccess.getOperationAccess().getRel_opAssignment_1_2(), "rule__Operation__Rel_opAssignment_1_2");
			builder.put(grammarAccess.getOperationAccess().getValueUmAssignment_2(), "rule__Operation__ValueUmAssignment_2");
			builder.put(grammarAccess.getOperationAccess().getValueDoisAssignment_3(), "rule__Operation__ValueDoisAssignment_3");
			builder.put(grammarAccess.getConditionalAccess().getCondAssignment_2(), "rule__Conditional__CondAssignment_2");
			builder.put(grammarAccess.getConditionalAccess().getTruthyAssignment_3(), "rule__Conditional__TruthyAssignment_3");
			builder.put(grammarAccess.getConditionalAccess().getFalsyAssignment_4(), "rule__Conditional__FalsyAssignment_4");
			builder.put(grammarAccess.getPrintAccess().getStringAssignment_1(), "rule__Print__StringAssignment_1");
			builder.put(grammarAccess.getListaAccess().getNumerosAssignment_5(), "rule__Lista__NumerosAssignment_5");
			builder.put(grammarAccess.getAnyAccess().getAnyIDAssignment_0(), "rule__Any__AnyIDAssignment_0");
			builder.put(grammarAccess.getAnyAccess().getAnyIntAssignment_1(), "rule__Any__AnyIntAssignment_1");
			builder.put(grammarAccess.getAnyAccess().getAnyStringAssignment_2(), "rule__Any__AnyStringAssignment_2");
			builder.put(grammarAccess.getAnyAccess().getAnyDefineAssignment_3(), "rule__Any__AnyDefineAssignment_3");
			builder.put(grammarAccess.getAnyAccess().getAnyLambdaAssignment_4(), "rule__Any__AnyLambdaAssignment_4");
			builder.put(grammarAccess.getAnyAccess().getAnyOperationAssignment_5(), "rule__Any__AnyOperationAssignment_5");
			builder.put(grammarAccess.getAnyAccess().getAnyConditionalAssignment_6(), "rule__Any__AnyConditionalAssignment_6");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private SchemeGrammarAccess grammarAccess;

	@Override
	protected InternalSchemeParser createParser() {
		InternalSchemeParser result = new InternalSchemeParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public SchemeGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(SchemeGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
